#include "StdAfx.h"
#include "Shoot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int System::NUM = 1000;//őǗIuWFNg
System* System::m_pThis = NULL;//B̃CX^X

//RXgN^
System::System(){
	m_pObjects = new MoveObject*[NUM];
	for ( int i = 0 ; i < NUM ; i++ ) {
		m_pObjects[i] = NULL;
	}
	m_nScore = 0;
	m_nHighScore = 0;
}

//fXgN^
System::~System() {
	if ( m_pObjects ) {
		for ( int i = 0 ; i < NUM ; i++ ) {
			if ( m_pObjects[i] != NULL ) {
				delete m_pObjects[i];
			}
		}
		delete [] m_pObjects;
	}
}

//B̃CX^X̎擾
System* System::GetInstance() {
	if ( m_pThis == NULL ) {
		m_pThis = new System;
		m_pThis->Add( new MyShip() );
	}
	return m_pThis;
}

//CX^Xj
void System::DeleteInstance(){
	if ( m_pThis != NULL ) {
		delete m_pThis;
		m_pThis = NULL;
	}
}

//IuWFNgǉ
bool System::Add( MoveObject* p ) {
	for ( int i = 0 ; i < NUM ; i++ ) {
		if ( m_pObjects[i] == NULL ) {
			m_pObjects[i] = p;
			return true;//ǉ
		}
	}
	delete p;
	return false;
}

//IuWFNg폜
void System::Delete( MoveObject* p ){
	for ( int i = 0 ; i < NUM ; i++ ) {
		if ( m_pObjects[i] == p ) {
			m_pObjects[i] = NULL;
			delete p;
			return;
		}
	}
	TRACE("Not Found!\n");
}

//SIuWFNg`
void System::Draw( CBaseView* pView,CDC* pDC ) {
	//g
	pView->MoveTo(pDC, 0,0); 
	pView->LineTo(pDC, 640,0);
	pView->LineTo(pDC, 640,480);
	pView->LineTo(pDC, 0,480);
	pView->LineTo(pDC, 0,0);
	//SIuWFNg`
	for ( int i = 0; i < NUM ; i++ ) {
		if ( m_pObjects[i] != NULL ) {
			m_pObjects[i]->Draw( pView, pDC );
		}
	}
}

//SIuWFNgړ
void System::Move( double dTick ) {
	//G
	if ( System::Rand() < 0.2 ) {
		Add( new EnemyA( CVector2d( 640 * System::Rand(), 0 ) ) );
	}
	//SIuWFNgړ
	for ( int i = 0; i < NUM ; i++ ) {
		if ( m_pObjects[i] != NULL ) {
			m_pObjects[i]->Move( dTick );
		}
	}
}

//蔻
void System::Hit() {
	for ( int i = 0; i < NUM ; i++ ) {
		if ( m_pObjects[i] == NULL ) continue;
		for ( int j = 0; j < NUM ; j++ ) {
			if ( HitTest(i,j) ) break;
		}
	}
}

//蔻iTuj
bool System::HitTest(int i, int j ) 
{
	if ( m_pObjects[i] == NULL 
		|| m_pObjects[j] == NULL 
		|| i == j ) return false;
	bool bHit = m_pObjects[i]->Hit( m_pObjects[j]->m_nType,
		m_pObjects[j]->m_vPos);
	if ( bHit == false ) return false;
	if ( m_pObjects[i]->m_nType == MoveObject::HT_MYSHIP ) {//@ŜƂ
		if ( m_nHighScore < m_nScore ) {
			m_nHighScore = m_nScore;
		}
		m_nScore = 0;
	} else if (m_pObjects[i]->m_nType == MoveObject::HT_ENEMY ) {//GŜƂ
		m_nScore ++;
		this->Delete( m_pObjects[i] );
	}
	return true;
}

//ʍŏ㕔ɕ\镶
void System::GetSceneName( char* pRet ) 
{
	sprintf(pRet,"Shooting2 : Score %06d Hi-Score %06d : "
		"Hit SHIFT to fire, Arrow to move!!", m_nScore, m_nHighScore);
}

//Vbv̈ʒu̎擾
CVector2d System::GetMyShipPos()
{
	if ( m_pObjects[0] != NULL ) {
		return m_pObjects[0]->m_vPos;
	} else {
		return CVector2d(320,240);
	}
}

//_ʃ|S̒ɓĂ邩
//vPoint : ׂ_
//nSide : |S̒_
//vPolygon : |S̒_inSide̔zj
bool System::PointInPolygon( const CVector2d& vPoint, int nSide, 
							 const CVector2d* vPolygon )
{
	CVector2d v1, v2;
	for ( int i = 0 ; i < nSide ; i++ ) {
		v1 = vPoint - vPolygon[i];
		v2 = vPolygon[(i+1)%nSide] - vPolygon[i];
		double z = v2.CrossProduct( v1 );
		if ( z > 0.0 ) return false;
	}
	return true;
}

//̃NX(ۃNXj
MoveObject::MoveObject() {//RXgN^
	m_vVelo = CVector2d(0.0, 0.0);
}
void MoveObject::Move( double dTick ) {//ړ
	m_vPos += m_vVelo * dTick;
}
bool MoveObject::Hit(  EHitType nType, const CVector2d& vPoint ){
	return false;
}

//[U[NXĩ~TCj
Leaser::Leaser( const CVector2d& p, const CVector2d& v ) {
	m_nType = MoveObject::HT_LEASER;
	m_vPos = p;
	m_vVelo = CVector2d( v.GetX() * 0.3, -450 );
}
void Leaser::Move( double dTick ) {
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetY() < 0 ) {
		System::GetInstance()->Delete( this );
	}
}
void Leaser::Draw( CBaseView* pView, CDC* pDC ) {
	//c`
	pView->MoveTo(pDC, m_vPos + CVector2d(0,-15));
	pView->LineTo(pDC, m_vPos + CVector2d(0, 15));
}

//VbvijNX
MyShip::MyShip() {
	m_nType = MoveObject::HT_MYSHIP;
	m_vPos = CVector2d(320,400);
}
void MyShip::Move( double dTick ) {
	//ړ
	CVector2d a(0,0);
	if ( GetAsyncKeyState( VK_LEFT ) < 0 ) a += CVector2d(-1,0);
	if ( GetAsyncKeyState( VK_RIGHT ) < 0 ) a += CVector2d(1,0);
	if ( GetAsyncKeyState( VK_UP ) < 0 ) a += CVector2d(0,-1);
	if ( GetAsyncKeyState( VK_DOWN ) < 0 ) a += CVector2d(0,1);
	if ( a.GetLength() > 0 ) {//L[Ă
		m_vVelo = a * 300;
	}
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetX() < 0 ) m_vPos.SetX( 0 );
	if ( m_vPos.GetX() > 640 ) m_vPos.SetX( 640 );
	if ( m_vPos.GetY() < 0 ) m_vPos.SetY( 0 );
	if ( m_vPos.GetY() > 480 ) m_vPos.SetY( 480 );
	m_vVelo *= 0.7;//CR
	//~TC
	if ( GetAsyncKeyState( VK_SHIFT ) < 0 ) {
		System::GetInstance()->Add( new Leaser(m_vPos, m_vVelo) );
	}
}
void MyShip::Draw( CBaseView* pView, CDC* pDC ) {
	//Op``
	pView->MoveTo( pDC, m_vPos + CVector2d(0,-30) );
	pView->LineTo( pDC, m_vPos + CVector2d(-20,15) );
	pView->LineTo( pDC, m_vPos + CVector2d( 20,15) );
	pView->LineTo( pDC, m_vPos + CVector2d(0,-30) );
}
bool MyShip::Hit(  EHitType nType, const CVector2d& vPoint ){
	if ( nType == HT_LEASER || nType == HT_EXPLOSION ) return false;
	CVector2d v[3];
	v[0] = m_vPos + CVector2d(0,-30);
	v[1] = m_vPos + CVector2d(-20,15);
	v[2] = m_vPos + CVector2d( 20,15);
	bool bHit = System::PointInPolygon( vPoint, 3, v );
	if ( bHit ) {//@S
		System::GetInstance()->Add(new Explosion( m_vPos ));
	}
	return bHit;
}


//GA
EnemyA::EnemyA( const CVector2d& p ) {
	m_nType = MoveObject::HT_ENEMY;
	m_vPos = p;
	m_vVelo = CVector2d( 10 * System::Rand()-5, 150.0 + System::Rand() * 100.0 );
	m_dwBorn = 0;
}
void EnemyA::Move( double dTick ) {
	System* pSys = System::GetInstance();
	double t = (double)(GetTickCount() - m_dwBorn)/1000.0;
	m_vVelo += CVector2d( 10 * sin( t * 5.0 ), 0 );
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetY() > 480 ) {//ʂo
		pSys->Delete(this);
	}
	if ( System::Rand() < 0.05 ) {//~TC
		pSys->Add( new MissileA( m_vPos, pSys->GetMyShipPos() ) );
	}
}
void EnemyA::Draw( CBaseView* pView, CDC* pDC ) {
	//Op``
	pView->MoveTo( pDC, m_vPos + CVector2d(0,20) );
	pView->LineTo( pDC, m_vPos + CVector2d( 20,-15) );
	pView->LineTo( pDC, m_vPos + CVector2d(-20,-15) );
	pView->LineTo( pDC, m_vPos + CVector2d(0,20) );
}
bool EnemyA::Hit(  EHitType nType, const CVector2d& vPoint ){
	if ( nType == HT_MISSILE || nType == HT_ENEMY 
		|| nType == HT_EXPLOSION ) return false;
	CVector2d v[3];
	v[0] = m_vPos + CVector2d(0,20);
	v[1] = m_vPos + CVector2d( 20,-15);
	v[2] = m_vPos + CVector2d(-20,-15);
	bool bHit = System::PointInPolygon( vPoint, 3, v );
	if ( bHit ) {
		System* pSys = System::GetInstance();
		pSys->GetInstance()->Add(new Explosion( m_vPos ));
	}
	return bHit;
}


//~TCANX
MissileA::MissileA( const CVector2d& from, const CVector2d& to ){
	m_nType = MoveObject::HT_MISSILE;
	m_vPos = from;
	m_vVelo = to - from;
	m_vVelo.Normalize();
	m_vVelo *= 200;//~TC̑x
}
void MissileA::Move( double dTick )
{
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetX() < 0 ||
		 m_vPos.GetX() > 640 || 
		 m_vPos.GetY() < 0 ||
		 m_vPos.GetY() > 480 ) {
		System::GetInstance()->Delete(this);
	}
}
void MissileA::Draw( CBaseView* pView, CDC* pDC )
{
	pView->Circle( pDC, m_vPos, 5 );
}

//NX
Explosion::Explosion( const CVector2d& p ) {
	m_nType = MoveObject::HT_EXPLOSION;
	m_vPos = p;
	m_vVelo = CVector2d( 0, 0 );
	m_dSize = 10;
	m_dLife = 0.0;
}
void Explosion::Move( double dTick ) {
	m_vPos += m_vVelo * dTick;
	m_dLife += dTick; //܂Ă̎Ԃ𑝂₷
	m_dSize += 60 * dTick;
	if ( m_dLife > 0.8 ) {//2bŏ
		System::GetInstance()->Delete( this );
	}
}
void Explosion::Draw( CBaseView* pView, CDC* pDC ) {
	pView->Circle( pDC, m_vPos, m_dSize );
	pView->Circle( pDC, m_vPos, m_dSize * 0.95);
}
