#include "BaseDoc.h"
#include "BaseView.h"

//NXgp錾
class MoveObject;
//Q[VXeNX
class System {
	static const int NUM;
	static System* m_pThis;
	MoveObject** m_pObjects;
	int m_nScore;
	int m_nHighScore;
	//RXgN^(singleton)
	System();
	//蔻
	bool HitTest(int i, int j ); 
public:
	//fXgN^
	~System();
	//CX^X擾
	static System* GetInstance();
	//CX^Xj
	static void DeleteInstance();
	//IuWFNgǉ
	bool Add( MoveObject* p );
	//IuWFNg폜
	void Delete( MoveObject* p );
	//`
	void Draw( CBaseView* pView,CDC* pDC );
	//ړ
	void Move( double dTick );
	//Vbv̈ʒu̎擾
	CVector2d GetMyShipPos();
	//蔻
	void Hit();
	//V[̏o
	void GetSceneName( char* pRet ); 
	//i 0.0 <= Rand() < 1.0 )
	static inline double Rand() {
		return (double)rand() / 32768.0;
	}
	//_ʃ|S̒ɓĂ邩
	static bool PointInPolygon( const CVector2d& vPoint, int nSide, 
		const CVector2d* vPolygon );
};

//̃NX(ۃNXj
class MoveObject {
public:
	enum EHitType {
		HT_MYSHIP,//@
		HT_LEASER,//̒e
		HT_ENEMY,//G
		HT_MISSILE,//G̒e
		HT_EXPLOSION,//
	};
	CVector2d m_vPos;//ʒu
	CVector2d m_vVelo;//x
	EHitType m_nType;//蔻p^Cv
	//RXgN^
	MoveObject();
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC ) = 0;//`
	virtual bool Hit( EHitType nType, const CVector2d& vPoint );//蔻
};

//[U[NXĩ~TCj
class Leaser : public MoveObject{
public:
	Leaser( const CVector2d& p, const CVector2d& v );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

//VbvijNX
class MyShip : public MoveObject{
public:
	MyShip();
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
	virtual bool Hit( EHitType nType, const CVector2d& vPoint );//蔻
};

//GANX
class EnemyA : public MoveObject {
	DWORD m_dwBorn;//܂ꂽ
public:
	EnemyA( const CVector2d& p );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
	virtual bool Hit( EHitType nType, const CVector2d& vPoint );//蔻
};

//~TCANX
class MissileA : public MoveObject {
public:
	MissileA( const CVector2d& from, const CVector2d& to );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

//NX
class Explosion : public MoveObject{
	double m_dSize;//݂̔a
	double m_dLife;//܂Ă̎(b)
public:
	Explosion( const CVector2d& p );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

